Subject: How to find an unused TAP device with kernel 3.8 ?

From: Toralf Förster <[email-masked]>
Date: Sat, 26 Jan 2013 11:29:49 +0100

With kernel 3.8. I just realized that all pre-defined TAP devices are
RUNNING even if no virtual linux system is using it. Now I'm wondering
whether this is a new feature of the upcoming kernel, a bug of the old -
and how I can avoid that.

Background : When I start a user mode linux instance, I currently grep
for the next free tap device in this way :

Code:	
for t in $(ifconfig | grep "^tap" | cut -f1 -d:)
do
   ethtool $t | grep -q 'Link detected: no'
   if [[ $? -eq 0 ]]; then
      NET="tuntap,$t"
      break
   fi
done

but this doesn't work now anymore.

Here is the diff in dmesg

$ diff 3.7.1 3.8.0-rc1+ | grep UP

< br0: flags=4355<UP,BROADCAST,PROMISC,MULTICAST>  mtu 1500
> br0: flags=4419<UP,BROADCAST,RUNNING,PROMISC,MULTICAST>  mtu 1500

< tap0: flags=4099<UP,BROADCAST,MULTICAST>  mtu 1500
> tap0: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500

more details : http://forums.gentoo.org/viewtopic-p-7211498.html#7211498

-- 
MfG/Sincerely
Toralf Förster
pgp finger print: 7B1A 07F4 EC82 0F90 D4C2 8936 872A E508 7DB6 9DA3